<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>Khepera Library: kb_camera.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="kteamdoxy.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Khepera Library
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('kb__camera_8c.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">kb_camera.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Functions for accessing camera.  
<a href="#details">More...</a></p>
<div class="textblock"><div class="dynheader">
Include dependency graph for kb_camera.c:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c__incl.png" border="0" usemap="#kb__camera_8c" alt=""/></div>
<map name="kb__camera_8c" id="kb__camera_8c">
<area shape="rect" id="node20" href="kb__camera_8h.html" title="header of Funtions for camera access " alt="" coords="1773,80,1869,107"/></map>
</div>
</div>
<p><a href="kb__camera_8c_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structbuffer.html">buffer</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ab8444aa53cfd06b8d9b7162938990451"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ab8444aa53cfd06b8d9b7162938990451">ITU_R_FLOAT</a></td></tr>
<tr class="separator:ab8444aa53cfd06b8d9b7162938990451"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5613e775ec7b8d3bcf1123c6c0cbb3b5"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a5613e775ec7b8d3bcf1123c6c0cbb3b5">IO_READ</a></td></tr>
<tr class="separator:a5613e775ec7b8d3bcf1123c6c0cbb3b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a491f18141f5fac923e6ce75d4234b20d"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a491f18141f5fac923e6ce75d4234b20d">IO_MMAP</a></td></tr>
<tr class="separator:a491f18141f5fac923e6ce75d4234b20d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4312d2370be490a08395564871a7f154"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a4312d2370be490a08395564871a7f154">IO_USERPTR</a></td></tr>
<tr class="separator:a4312d2370be490a08395564871a7f154"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0ba4dd6e237b96132c0a66be2fb3bc2"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ab0ba4dd6e237b96132c0a66be2fb3bc2">CLEAR</a>(x)&#160;&#160;&#160;memset (&amp;(x), 0, sizeof (x))</td></tr>
<tr class="separator:ab0ba4dd6e237b96132c0a66be2fb3bc2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a50b34ba92cdf1719e959917a170b086c"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a50b34ba92cdf1719e959917a170b086c">VIDIOC_REQBUFS_COUNT</a>&#160;&#160;&#160;2</td></tr>
<tr class="separator:a50b34ba92cdf1719e959917a170b086c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a916e92ae9237b31e838e362c5e75ab51"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a916e92ae9237b31e838e362c5e75ab51">CLIP</a>(x)&#160;&#160;&#160;( (x)&gt;=0xFF ? 0xFF : ( (x) &lt;= 0x00 ? 0x00 : (x) ) )</td></tr>
<tr class="separator:a916e92ae9237b31e838e362c5e75ab51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a916e92ae9237b31e838e362c5e75ab51"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a916e92ae9237b31e838e362c5e75ab51">CLIP</a>(x)&#160;&#160;&#160;( (x)&gt;=0xFF ? 0xFF : ( (x) &lt;= 0x00 ? 0x00 : (x) ) )</td></tr>
<tr class="separator:a916e92ae9237b31e838e362c5e75ab51"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:ac67fbcc615b56da3f9e3d51b1a2d2d27"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27">io_method</a> { <a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27a6d138b4c4e5691ae5318dca4a80e8e79">IO_METHOD_READ</a>, 
<a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27a086ff945a7be166d4e465dd5b8ae8749">IO_METHOD_MMAP</a>, 
<a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27ab03186564baddf26b211a7b6fe7e8fe3">IO_METHOD_USERPTR</a>
 }</td></tr>
<tr class="separator:ac67fbcc615b56da3f9e3d51b1a2d2d27"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ad0d0aa54eaaf9770da0144705d892176"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ad0d0aa54eaaf9770da0144705d892176">YUV420toYUV444</a> (int width, int height, unsigned char *src, unsigned char *dst)</td></tr>
<tr class="separator:ad0d0aa54eaaf9770da0144705d892176"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9805db4388486870b513f5246e889c04"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a9805db4388486870b513f5246e889c04">YUV420toRGB888</a> (int width, int height, unsigned char *src, unsigned char *dst)</td></tr>
<tr class="separator:a9805db4388486870b513f5246e889c04"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac07d4b713203275e34515fbf88a66a00"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ac07d4b713203275e34515fbf88a66a00">YUV422toRGB888</a> (int width, int height, unsigned char *src, unsigned char *dst)</td></tr>
<tr class="separator:ac07d4b713203275e34515fbf88a66a00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d8f200cc041f8544260bdd5dbba2935"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935">xioctl</a> (int <a class="el" href="kb__camera_8c.html#a6f8059414f0228f0256115e024eeed4b">fd</a>, int request, void *argp)</td></tr>
<tr class="separator:a8d8f200cc041f8544260bdd5dbba2935"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0e1971762d2d6b5ad91c1d263bf163e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ac0e1971762d2d6b5ad91c1d263bf163e">readInit</a> (unsigned int buffer_size)</td></tr>
<tr class="separator:ac0e1971762d2d6b5ad91c1d263bf163e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af3a6ddae0f3a0a27b9733d6ad712fa98"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#af3a6ddae0f3a0a27b9733d6ad712fa98">mmapInit</a> (void)</td></tr>
<tr class="separator:af3a6ddae0f3a0a27b9733d6ad712fa98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abed5856d5e01aabbdd85dbb8c2071099"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#abed5856d5e01aabbdd85dbb8c2071099">userptrInit</a> (unsigned int buffer_size)</td></tr>
<tr class="separator:abed5856d5e01aabbdd85dbb8c2071099"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abde1e7caac208faee05c446c96ab166a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#abde1e7caac208faee05c446c96ab166a">deviceInit</a> (void)</td></tr>
<tr class="separator:abde1e7caac208faee05c446c96ab166a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a2be3ff0ad4661a87b9171f2e41a9ba"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a0a2be3ff0ad4661a87b9171f2e41a9ba">deviceUninit</a> (void)</td></tr>
<tr class="separator:a0a2be3ff0ad4661a87b9171f2e41a9ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4262f7805b5cb10f5b5d4dc76c5da145"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a4262f7805b5cb10f5b5d4dc76c5da145">deviceOpen</a> (void)</td></tr>
<tr class="separator:a4262f7805b5cb10f5b5d4dc76c5da145"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4901e89adae4b26c5ce8a99d1ad2fcc"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#af4901e89adae4b26c5ce8a99d1ad2fcc">deviceClose</a> (void)</td></tr>
<tr class="separator:af4901e89adae4b26c5ce8a99d1ad2fcc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0679b21b5a0bbb78176bca1c981a4764"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a0679b21b5a0bbb78176bca1c981a4764">jpegWrite</a> (unsigned char *img)</td></tr>
<tr class="separator:a0679b21b5a0bbb78176bca1c981a4764"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7072a360758c08468d30e386193d1b3f"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a7072a360758c08468d30e386193d1b3f">imageProcess</a> (const void *p, unsigned char *<a class="el" href="structbuffer.html">buffer</a>)</td></tr>
<tr class="separator:a7072a360758c08468d30e386193d1b3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08555bca12d9ddf0da79caac817d82e5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a08555bca12d9ddf0da79caac817d82e5">frameRead</a> (unsigned char *output)</td></tr>
<tr class="separator:a08555bca12d9ddf0da79caac817d82e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27c707e097823b674f6290c8741fe3a1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a27c707e097823b674f6290c8741fe3a1">kb_frameRead</a> (unsigned char *output)</td></tr>
<tr class="separator:a27c707e097823b674f6290c8741fe3a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5d543c2f1e8ba407b09d0b9e1e65aec"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ae5d543c2f1e8ba407b09d0b9e1e65aec">kb_captureStop</a> (void)</td></tr>
<tr class="separator:ae5d543c2f1e8ba407b09d0b9e1e65aec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a4beff6868578e54ef05f1b5290ba55"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a6a4beff6868578e54ef05f1b5290ba55">kb_captureStart</a> (void)</td></tr>
<tr class="separator:a6a4beff6868578e54ef05f1b5290ba55"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd653987fde99618ada043e5aa6b1d6c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#afd653987fde99618ada043e5aa6b1d6c">into_greyscale</a> (unsigned char *src)</td></tr>
<tr class="separator:afd653987fde99618ada043e5aa6b1d6c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b7e3f6bef111932c7e4e45e1e541ce9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a7b7e3f6bef111932c7e4e45e1e541ce9">apply_filter</a> (unsigned char *src, unsigned char *dst, int *filter_x_array, int *filter_y_array, int filter_dim_x, int filter_dim_y)</td></tr>
<tr class="separator:a7b7e3f6bef111932c7e4e45e1e541ce9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae3bd54c1384babc07d263466d5d826d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#aae3bd54c1384babc07d263466d5d826d">kb_camera_init</a> (unsigned int *width, unsigned int *height)</td></tr>
<tr class="separator:aae3bd54c1384babc07d263466d5d826d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a9f62e47c659cfda8a617813fca6f22"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a0a9f62e47c659cfda8a617813fca6f22">kb_camera_release</a> (void)</td></tr>
<tr class="separator:a0a9f62e47c659cfda8a617813fca6f22"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a396f3dad7062f3b1d624171bf6652e24"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a396f3dad7062f3b1d624171bf6652e24">take_one_image</a> (unsigned char *<a class="el" href="structbuffer.html">buffer</a>)</td></tr>
<tr class="separator:a396f3dad7062f3b1d624171bf6652e24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13cf1fd9bd4ab412dda14cd52dfea219"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a13cf1fd9bd4ab412dda14cd52dfea219">save_buffer_to_jpg</a> (const char *<a class="el" href="klrf__test_8c.html#a258adbf16b88a7db88c7d8bce9708c50">filename</a>, int quality, unsigned char *<a class="el" href="structbuffer.html">buffer</a>)</td></tr>
<tr class="separator:a13cf1fd9bd4ab412dda14cd52dfea219"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:ad1198d3ea2644952f5513716b093a40f"><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#ad1198d3ea2644952f5513716b093a40f">dWidth</a> = 752</td></tr>
<tr class="separator:ad1198d3ea2644952f5513716b093a40f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af235a7300301c4544d2ec5a980a26202"><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#af235a7300301c4544d2ec5a980a26202">dHeight</a> = 480</td></tr>
<tr class="separator:af235a7300301c4544d2ec5a980a26202"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaada36991566317f46721dd5da76407e"><td class="memItemLeft" align="right" valign="top">static unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#aaada36991566317f46721dd5da76407e">jpegQuality</a> = 70</td></tr>
<tr class="separator:aaada36991566317f46721dd5da76407e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4cb02037fe3d044e7df04e7ba730b48c"><td class="memItemLeft" align="right" valign="top">static char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a4cb02037fe3d044e7df04e7ba730b48c">jpegFilename</a></td></tr>
<tr class="separator:a4cb02037fe3d044e7df04e7ba730b48c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0256d25b86a9f6d108e63e630fd20cf2"><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a0256d25b86a9f6d108e63e630fd20cf2">fps</a> = -1</td></tr>
<tr class="separator:a0256d25b86a9f6d108e63e630fd20cf2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5da66826e811349c98b2daf2bafb78c2"><td class="memItemLeft" align="right" valign="top">static char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a5da66826e811349c98b2daf2bafb78c2">deviceName</a> = &quot;/dev/video6&quot;</td></tr>
<tr class="separator:a5da66826e811349c98b2daf2bafb78c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec080b31a9d99ef26786ddb817e892e1"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27">io_method</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#aec080b31a9d99ef26786ddb817e892e1">io</a> = <a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27a086ff945a7be166d4e465dd5b8ae8749">IO_METHOD_MMAP</a></td></tr>
<tr class="separator:aec080b31a9d99ef26786ddb817e892e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f8059414f0228f0256115e024eeed4b"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a6f8059414f0228f0256115e024eeed4b">fd</a> = -1</td></tr>
<tr class="separator:a6f8059414f0228f0256115e024eeed4b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86b667e9fcefc20145a0052a662dd961"><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a86b667e9fcefc20145a0052a662dd961">initialised</a> =0</td></tr>
<tr class="separator:a86b667e9fcefc20145a0052a662dd961"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3bdcdddaf116b83e1e4ee5f9f7d66da0"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="structbuffer.html">buffer</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#a3bdcdddaf116b83e1e4ee5f9f7d66da0">buffers</a> = NULL</td></tr>
<tr class="separator:a3bdcdddaf116b83e1e4ee5f9f7d66da0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe157a787e311212531b003b24674227"><td class="memItemLeft" align="right" valign="top">static unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="kb__camera_8c.html#afe157a787e311212531b003b24674227">n_buffers</a> = 0</td></tr>
<tr class="separator:afe157a787e311212531b003b24674227"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Functions for accessing camera. </p>

<p>Definition in file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a class="anchor" id="ab0ba4dd6e237b96132c0a66be2fb3bc2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define CLEAR</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">x</td><td>)</td>
          <td>&#160;&#160;&#160;memset (&amp;(x), 0, sizeof (x))</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00108">108</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>, <a class="el" href="kb__camera_8c_source.html#l01087">kb_captureStart()</a>, <a class="el" href="kb__camera_8c_source.html#l00360">mmapInit()</a>, and <a class="el" href="kb__camera_8c_source.html#l00429">userptrInit()</a>.</p>

</div>
</div>
<a class="anchor" id="a916e92ae9237b31e838e362c5e75ab51"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define CLIP</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">x</td><td>)</td>
          <td>&#160;&#160;&#160;( (x)&gt;=0xFF ? 0xFF : ( (x) &lt;= 0x00 ? 0x00 : (x) ) )</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00193">YUV420toRGB888()</a>, and <a class="el" href="kb__camera_8c_source.html#l00249">YUV422toRGB888()</a>.</p>

</div>
</div>
<a class="anchor" id="a916e92ae9237b31e838e362c5e75ab51"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define CLIP</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">x</td><td>)</td>
          <td>&#160;&#160;&#160;( (x)&gt;=0xFF ? 0xFF : ( (x) &lt;= 0x00 ? 0x00 : (x) ) )</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a491f18141f5fac923e6ce75d4234b20d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IO_MMAP</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00103">103</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<a class="anchor" id="a5613e775ec7b8d3bcf1123c6c0cbb3b5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IO_READ</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00102">102</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<a class="anchor" id="a4312d2370be490a08395564871a7f154"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IO_USERPTR</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00104">104</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<a class="anchor" id="ab8444aa53cfd06b8d9b7162938990451"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ITU_R_FLOAT</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00093">93</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<a class="anchor" id="a50b34ba92cdf1719e959917a170b086c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define VIDIOC_REQBUFS_COUNT&#160;&#160;&#160;2</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00112">112</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00360">mmapInit()</a>, and <a class="el" href="kb__camera_8c_source.html#l00429">userptrInit()</a>.</p>

</div>
</div>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a class="anchor" id="ac67fbcc615b56da3f9e3d51b1a2d2d27"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27">io_method</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><em><a class="anchor" id="ac67fbcc615b56da3f9e3d51b1a2d2d27a6d138b4c4e5691ae5318dca4a80e8e79"></a>IO_METHOD_READ</em>&#160;</td><td class="fielddoc">
</td></tr>
<tr><td class="fieldname"><em><a class="anchor" id="ac67fbcc615b56da3f9e3d51b1a2d2d27a086ff945a7be166d4e465dd5b8ae8749"></a>IO_METHOD_MMAP</em>&#160;</td><td class="fielddoc">
</td></tr>
<tr><td class="fieldname"><em><a class="anchor" id="ac67fbcc615b56da3f9e3d51b1a2d2d27ab03186564baddf26b211a7b6fe7e8fe3"></a>IO_METHOD_USERPTR</em>&#160;</td><td class="fielddoc">
</td></tr>
</table>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00115">115</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="a7b7e3f6bef111932c7e4e45e1e541ce9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int apply_filter </td>
          <td>(</td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>filter_x_array</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>filter_y_array</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>filter_dim_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>filter_dim_y</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>apply array filter on greyscale image</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>source of image </td></tr>
    <tr><td class="paramname">dst</td><td>destination of processed image </td></tr>
    <tr><td class="paramname">filter_x_array</td><td>filter square array for column dimension </td></tr>
    <tr><td class="paramname">filter_y_array</td><td>filter square array for line dimension </td></tr>
    <tr><td class="paramname">filter_dim_x</td><td>size of filter for column dimension; must be odd </td></tr>
    <tr><td class="paramname">filter_dim_y</td><td>size of filter for line dimension; must be odd</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value: -1 : source image memory is NULL -2 : destination image memory is NULL -3 : filter x size is not an odd number &gt;0 -4 : filter x size is not an odd number &gt;0 0 : on success </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01197">1197</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00129">dHeight</a>, and <a class="el" href="kb__camera_8c_source.html#l00128">dWidth</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>.</p>

</div>
</div>
<a class="anchor" id="af4901e89adae4b26c5ce8a99d1ad2fcc"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void deviceClose </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>close device </p>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00731">731</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01360">kb_camera_release()</a>.</p>

</div>
</div>
<a class="anchor" id="abde1e7caac208faee05c446c96ab166a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int deviceInit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>initialize device</p>
<p>return: -1 : no device /dev/video0 -2 : no video capture device -3 : capabilities error 0 : on success 1 : image width adjusted 2 : image height adjusted 3 : image height + width adjusted </p>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00490">490</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00108">CLEAR</a>, <a class="el" href="kb__camera_8c_source.html#l00129">dHeight</a>, <a class="el" href="kb__camera_8c_source.html#l00128">dWidth</a>, <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00132">fps</a>, <a class="el" href="kb__camera_8c_source.html#l00139">initialised</a>, <a class="el" href="kb__camera_8c_source.html#l00136">io</a>, <a class="el" href="kb__camera_8c_source.html#l00120">IO_METHOD_MMAP</a>, <a class="el" href="kb__camera_8c_source.html#l00117">IO_METHOD_READ</a>, <a class="el" href="kb__camera_8c_source.html#l00123">IO_METHOD_USERPTR</a>, <a class="el" href="kb__camera_8c_source.html#l00360">mmapInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00326">readInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00429">userptrInit()</a>, and <a class="el" href="kb__camera_8c_source.html#l00306">xioctl()</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01296">kb_camera_init()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_abde1e7caac208faee05c446c96ab166a_cgraph.png" border="0" usemap="#kb__camera_8c_abde1e7caac208faee05c446c96ab166a_cgraph" alt=""/></div>
<map name="kb__camera_8c_abde1e7caac208faee05c446c96ab166a_cgraph" id="kb__camera_8c_abde1e7caac208faee05c446c96ab166a_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#af3a6ddae0f3a0a27b9733d6ad712fa98" title="mmapInit" alt="" coords="133,5,209,32"/><area shape="rect" id="node3" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="259,56,311,83"/><area shape="rect" id="node4" href="kb__camera_8c.html#ac0e1971762d2d6b5ad91c1d263bf163e" title="readInit" alt="" coords="138,107,203,133"/><area shape="rect" id="node5" href="kb__camera_8c.html#abed5856d5e01aabbdd85dbb8c2071099" title="userptrInit" alt="" coords="131,157,210,184"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a4262f7805b5cb10f5b5d4dc76c5da145"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int deviceOpen </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00697">697</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00134">deviceName</a>, and <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01296">kb_camera_init()</a>.</p>

</div>
</div>
<a class="anchor" id="a0a2be3ff0ad4661a87b9171f2e41a9ba"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int deviceUninit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00656">656</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00139">initialised</a>, <a class="el" href="kb__camera_8c_source.html#l00136">io</a>, <a class="el" href="kb__camera_8c_source.html#l00120">IO_METHOD_MMAP</a>, <a class="el" href="kb__camera_8c_source.html#l00117">IO_METHOD_READ</a>, <a class="el" href="kb__camera_8c_source.html#l00123">IO_METHOD_USERPTR</a>, and <a class="el" href="kb__camera_8c_source.html#l00148">n_buffers</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01360">kb_camera_release()</a>.</p>

</div>
</div>
<a class="anchor" id="a08555bca12d9ddf0da79caac817d82e5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int frameRead </td>
          <td>(</td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>output</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00847">847</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00108">CLEAR</a>, <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00807">imageProcess()</a>, <a class="el" href="kb__camera_8c_source.html#l00136">io</a>, <a class="el" href="kb__camera_8c_source.html#l00120">IO_METHOD_MMAP</a>, <a class="el" href="kb__camera_8c_source.html#l00117">IO_METHOD_READ</a>, <a class="el" href="kb__camera_8c_source.html#l00123">IO_METHOD_USERPTR</a>, <a class="el" href="kb__camera_8c_source.html#l00143">buffer::length</a>, <a class="el" href="kb__camera_8c_source.html#l00148">n_buffers</a>, <a class="el" href="kb__camera_8c_source.html#l00142">buffer::start</a>, and <a class="el" href="kb__camera_8c_source.html#l00306">xioctl()</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00977">kb_frameRead()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a08555bca12d9ddf0da79caac817d82e5_cgraph.png" border="0" usemap="#kb__camera_8c_a08555bca12d9ddf0da79caac817d82e5_cgraph" alt=""/></div>
<map name="kb__camera_8c_a08555bca12d9ddf0da79caac817d82e5_cgraph" id="kb__camera_8c_a08555bca12d9ddf0da79caac817d82e5_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a7072a360758c08468d30e386193d1b3f" title="imageProcess" alt="" coords="139,5,242,32"/><area shape="rect" id="node4" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="165,56,217,83"/><area shape="rect" id="node3" href="kb__camera_8c.html#a9805db4388486870b513f5246e889c04" title="YUV420toRGB888" alt="" coords="291,5,421,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a7072a360758c08468d30e386193d1b3f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int imageProcess </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>p</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>buffer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>process image read: convert to RGB 8 bit </p>
<dl class="section return"><dt>Returns</dt><dd>A value 0 : success -1 : buffer not initialised -2 : not enough memory into buffer </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00807">807</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00129">dHeight</a>, <a class="el" href="kb__camera_8c_source.html#l00128">dWidth</a>, and <a class="el" href="kb__camera_8c_source.html#l00193">YUV420toRGB888()</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a7072a360758c08468d30e386193d1b3f_cgraph.png" border="0" usemap="#kb__camera_8c_a7072a360758c08468d30e386193d1b3f_cgraph" alt=""/></div>
<map name="kb__camera_8c_a7072a360758c08468d30e386193d1b3f_cgraph" id="kb__camera_8c_a7072a360758c08468d30e386193d1b3f_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a9805db4388486870b513f5246e889c04" title="YUV420toRGB888" alt="" coords="158,5,287,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="afd653987fde99618ada043e5aa6b1d6c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int into_greyscale </td>
          <td>(</td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>src</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>convert to greyscale</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>image </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value: 0 : on success </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01167">1167</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00129">dHeight</a>, and <a class="el" href="kb__camera_8c_source.html#l00128">dWidth</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>.</p>

</div>
</div>
<a class="anchor" id="a0679b21b5a0bbb78176bca1c981a4764"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int jpegWrite </td>
          <td>(</td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>img</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Write image to jpeg file.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">img</td><td>image to write </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value -1 : cannot open file 0 : success </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00749">749</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00129">dHeight</a>, <a class="el" href="kb__camera_8c_source.html#l00128">dWidth</a>, <a class="el" href="kb__camera_8c_source.html#l00131">jpegFilename</a>, <a class="el" href="kb__camera_8c_source.html#l00130">jpegQuality</a>, and <a class="el" href="klrf__test_8c_source.html#l00025">outfile</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01468">save_buffer_to_jpg()</a>.</p>

</div>
</div>
<a class="anchor" id="aae3bd54c1384babc07d263466d5d826d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int kb_camera_init </td>
          <td>(</td>
          <td class="paramtype">unsigned int *&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int *&#160;</td>
          <td class="paramname"><em>height</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>initializes. This function needs to be called BEFORE any other functions.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">width</td><td>width of image; may be autonomoulsy adjusted and returned </td></tr>
    <tr><td class="paramname">height</td><td>height of image; may be autonomoulsy adjusted and returned</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value: -1 : no device /dev/video0 -2 : no video capture device -3 : capabilities error -4 : cannot open the device -5 : cannot call system for media-ctl pipes -6 : media-ctl pipes command exited with error -7 : cannot call system for media-ctl formats -8 : media-ctl formats command exited with error 0 : on success 1 : image width adjusted 2 : image height adjusted 3 : image height + width adjusted </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01296">1296</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00697">deviceOpen()</a>, <a class="el" href="kb__camera_8c_source.html#l00129">dHeight</a>, and <a class="el" href="kb__camera_8c_source.html#l00128">dWidth</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_aae3bd54c1384babc07d263466d5d826d_cgraph.png" border="0" usemap="#kb__camera_8c_aae3bd54c1384babc07d263466d5d826d_cgraph" alt=""/></div>
<map name="kb__camera_8c_aae3bd54c1384babc07d263466d5d826d_cgraph" id="kb__camera_8c_aae3bd54c1384babc07d263466d5d826d_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#abde1e7caac208faee05c446c96ab166a" title="deviceInit" alt="" coords="172,81,249,108"/><area shape="rect" id="node7" href="kb__camera_8c.html#a4262f7805b5cb10f5b5d4dc76c5da145" title="deviceOpen" alt="" coords="165,132,256,159"/><area shape="rect" id="node3" href="kb__camera_8c.html#af3a6ddae0f3a0a27b9733d6ad712fa98" title="mmapInit" alt="" coords="306,5,382,32"/><area shape="rect" id="node4" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="433,56,485,83"/><area shape="rect" id="node5" href="kb__camera_8c.html#ac0e1971762d2d6b5ad91c1d263bf163e" title="readInit" alt="" coords="311,107,377,133"/><area shape="rect" id="node6" href="kb__camera_8c.html#abed5856d5e01aabbdd85dbb8c2071099" title="userptrInit" alt="" coords="305,157,383,184"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a0a9f62e47c659cfda8a617813fca6f22"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void kb_camera_release </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>release the camera and device</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">none</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value:<ul>
<li>-1 cannot open the device</li>
<li>0 on success </li>
</ul>
</dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01360">1360</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00731">deviceClose()</a>, <a class="el" href="kb__camera_8c_source.html#l00656">deviceUninit()</a>, and <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a0a9f62e47c659cfda8a617813fca6f22_cgraph.png" border="0" usemap="#kb__camera_8c_a0a9f62e47c659cfda8a617813fca6f22_cgraph" alt=""/></div>
<map name="kb__camera_8c_a0a9f62e47c659cfda8a617813fca6f22_cgraph" id="kb__camera_8c_a0a9f62e47c659cfda8a617813fca6f22_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#af4901e89adae4b26c5ce8a99d1ad2fcc" title="deviceClose" alt="" coords="191,5,281,32"/><area shape="rect" id="node3" href="kb__camera_8c.html#a0a2be3ff0ad4661a87b9171f2e41a9ba" title="deviceUninit" alt="" coords="190,56,282,83"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a6a4beff6868578e54ef05f1b5290ba55"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int kb_captureStart </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Start capturing multiple frames</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">(none)</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value 0 : success -1 : VIDIOC_QBUF error -2 : VIDIOC_STREAMON error </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01087">1087</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00108">CLEAR</a>, <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00136">io</a>, <a class="el" href="kb__camera_8c_source.html#l00120">IO_METHOD_MMAP</a>, <a class="el" href="kb__camera_8c_source.html#l00117">IO_METHOD_READ</a>, <a class="el" href="kb__camera_8c_source.html#l00123">IO_METHOD_USERPTR</a>, <a class="el" href="kb__camera_8c_source.html#l00143">buffer::length</a>, <a class="el" href="kb__camera_8c_source.html#l00148">n_buffers</a>, and <a class="el" href="kb__camera_8c_source.html#l00306">xioctl()</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>, and <a class="el" href="kb__camera_8c_source.html#l01388">take_one_image()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a6a4beff6868578e54ef05f1b5290ba55_cgraph.png" border="0" usemap="#kb__camera_8c_a6a4beff6868578e54ef05f1b5290ba55_cgraph" alt=""/></div>
<map name="kb__camera_8c_a6a4beff6868578e54ef05f1b5290ba55_cgraph" id="kb__camera_8c_a6a4beff6868578e54ef05f1b5290ba55_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="169,5,221,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ae5d543c2f1e8ba407b09d0b9e1e65aec"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int kb_captureStop </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Stop capturing multiple frames</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">(none)</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value 0 : success -1 : VIDIOC_STREAMOFF error </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01046">1046</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00136">io</a>, <a class="el" href="kb__camera_8c_source.html#l00120">IO_METHOD_MMAP</a>, <a class="el" href="kb__camera_8c_source.html#l00117">IO_METHOD_READ</a>, <a class="el" href="kb__camera_8c_source.html#l00123">IO_METHOD_USERPTR</a>, and <a class="el" href="kb__camera_8c_source.html#l00306">xioctl()</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>, and <a class="el" href="kb__camera_8c_source.html#l01388">take_one_image()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_ae5d543c2f1e8ba407b09d0b9e1e65aec_cgraph.png" border="0" usemap="#kb__camera_8c_ae5d543c2f1e8ba407b09d0b9e1e65aec_cgraph" alt=""/></div>
<map name="kb__camera_8c_ae5d543c2f1e8ba407b09d0b9e1e65aec_cgraph" id="kb__camera_8c_ae5d543c2f1e8ba407b09d0b9e1e65aec_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="169,5,221,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a27c707e097823b674f6290c8741fe3a1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int kb_frameRead </td>
          <td>(</td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>output</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00977">977</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, and <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>, and <a class="el" href="kb__camera_8c_source.html#l01388">take_one_image()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a27c707e097823b674f6290c8741fe3a1_cgraph.png" border="0" usemap="#kb__camera_8c_a27c707e097823b674f6290c8741fe3a1_cgraph" alt=""/></div>
<map name="kb__camera_8c_a27c707e097823b674f6290c8741fe3a1_cgraph" id="kb__camera_8c_a27c707e097823b674f6290c8741fe3a1_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a08555bca12d9ddf0da79caac817d82e5" title="frameRead" alt="" coords="160,31,245,57"/><area shape="rect" id="node3" href="kb__camera_8c.html#a7072a360758c08468d30e386193d1b3f" title="imageProcess" alt="" coords="294,5,397,32"/><area shape="rect" id="node5" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="319,56,371,83"/><area shape="rect" id="node4" href="kb__camera_8c.html#a9805db4388486870b513f5246e889c04" title="YUV420toRGB888" alt="" coords="446,5,575,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="af3a6ddae0f3a0a27b9733d6ad712fa98"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mmapInit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00360">360</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00108">CLEAR</a>, <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00143">buffer::length</a>, <a class="el" href="kb__camera_8c_source.html#l00148">n_buffers</a>, <a class="el" href="kb__camera_8c_source.html#l00142">buffer::start</a>, <a class="el" href="kb__camera_8c_source.html#l00112">VIDIOC_REQBUFS_COUNT</a>, and <a class="el" href="kb__camera_8c_source.html#l00306">xioctl()</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_af3a6ddae0f3a0a27b9733d6ad712fa98_cgraph.png" border="0" usemap="#kb__camera_8c_af3a6ddae0f3a0a27b9733d6ad712fa98_cgraph" alt=""/></div>
<map name="kb__camera_8c_af3a6ddae0f3a0a27b9733d6ad712fa98_cgraph" id="kb__camera_8c_af3a6ddae0f3a0a27b9733d6ad712fa98_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="131,5,183,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ac0e1971762d2d6b5ad91c1d263bf163e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int readInit </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>buffer_size</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00326">326</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00143">buffer::length</a>, and <a class="el" href="kb__camera_8c_source.html#l00142">buffer::start</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>.</p>

</div>
</div>
<a class="anchor" id="a13cf1fd9bd4ab412dda14cd52dfea219"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int save_buffer_to_jpg </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>quality</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>buffer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>take an image buffer to jpeg file</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>filename of the image where is is saved </td></tr>
    <tr><td class="paramname">quality</td><td>jpeg quality in range [0-100] </td></tr>
    <tr><td class="paramname">buffer</td><td>image buffer</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value:<ul>
<li>-1 quality range error</li>
<li>-2 buffer error</li>
<li>-3 file write error</li>
<li>0 on success </li>
</ul>
</dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01468">1468</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00131">jpegFilename</a>, <a class="el" href="kb__camera_8c_source.html#l00130">jpegQuality</a>, and <a class="el" href="kb__camera_8c_source.html#l00749">jpegWrite()</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a13cf1fd9bd4ab412dda14cd52dfea219_cgraph.png" border="0" usemap="#kb__camera_8c_a13cf1fd9bd4ab412dda14cd52dfea219_cgraph" alt=""/></div>
<map name="kb__camera_8c_a13cf1fd9bd4ab412dda14cd52dfea219_cgraph" id="kb__camera_8c_a13cf1fd9bd4ab412dda14cd52dfea219_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a0679b21b5a0bbb78176bca1c981a4764" title="jpegWrite" alt="" coords="182,5,258,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a396f3dad7062f3b1d624171bf6652e24"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int take_one_image </td>
          <td>(</td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>buffer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>take an image in format : rgb 8 bit (RGB888)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">buffer</td><td>returned image</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A value:<ul>
<li>0 on success</li>
<li>-1 device not open</li>
<li>-2 device not initialised</li>
<li>-3 capture start error</li>
<li>-5 error stopping capture</li>
<li>-6 : read error into frameRead</li>
<li>-7 : VIDIOC_DQBUF error into frameRead</li>
<li>-8 : xioctl error into frameRead</li>
<li>-9 : try again into frameRead</li>
<li>-10 : buffer size error into frameRead </li>
</ul>
</dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l01388">1388</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00139">initialised</a>, <a class="el" href="kb__camera_8c_source.html#l01087">kb_captureStart()</a>, <a class="el" href="kb__camera_8c_source.html#l01046">kb_captureStop()</a>, and <a class="el" href="kb__camera_8c_source.html#l00977">kb_frameRead()</a>.</p>

<p>Referenced by <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_a396f3dad7062f3b1d624171bf6652e24_cgraph.png" border="0" usemap="#kb__camera_8c_a396f3dad7062f3b1d624171bf6652e24_cgraph" alt=""/></div>
<map name="kb__camera_8c_a396f3dad7062f3b1d624171bf6652e24_cgraph" id="kb__camera_8c_a396f3dad7062f3b1d624171bf6652e24_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a6a4beff6868578e54ef05f1b5290ba55" title="kb_captureStart" alt="" coords="333,5,448,32"/><area shape="rect" id="node4" href="kb__camera_8c.html#ae5d543c2f1e8ba407b09d0b9e1e65aec" title="kb_captureStop" alt="" coords="171,56,285,83"/><area shape="rect" id="node5" href="kb__camera_8c.html#a27c707e097823b674f6290c8741fe3a1" title="kb_frameRead" alt="" coords="175,107,281,133"/><area shape="rect" id="node3" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="522,56,574,83"/><area shape="rect" id="node6" href="kb__camera_8c.html#a08555bca12d9ddf0da79caac817d82e5" title="frameRead" alt="" coords="348,107,433,133"/><area shape="rect" id="node7" href="kb__camera_8c.html#a7072a360758c08468d30e386193d1b3f" title="imageProcess" alt="" coords="497,107,599,133"/><area shape="rect" id="node8" href="kb__camera_8c.html#a9805db4388486870b513f5246e889c04" title="YUV420toRGB888" alt="" coords="649,107,778,133"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="abed5856d5e01aabbdd85dbb8c2071099"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int userptrInit </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>buffer_size</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00429">429</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c_source.html#l00108">CLEAR</a>, <a class="el" href="kb__camera_8c_source.html#l00138">fd</a>, <a class="el" href="kb__camera_8c_source.html#l00143">buffer::length</a>, <a class="el" href="kb__camera_8c_source.html#l00148">n_buffers</a>, <a class="el" href="kb__camera_8c_source.html#l00142">buffer::start</a>, <a class="el" href="kb__camera_8c_source.html#l00112">VIDIOC_REQBUFS_COUNT</a>, and <a class="el" href="kb__camera_8c_source.html#l00306">xioctl()</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>.</p>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="kb__camera_8c_abed5856d5e01aabbdd85dbb8c2071099_cgraph.png" border="0" usemap="#kb__camera_8c_abed5856d5e01aabbdd85dbb8c2071099_cgraph" alt=""/></div>
<map name="kb__camera_8c_abed5856d5e01aabbdd85dbb8c2071099_cgraph" id="kb__camera_8c_abed5856d5e01aabbdd85dbb8c2071099_cgraph">
<area shape="rect" id="node2" href="kb__camera_8c.html#a8d8f200cc041f8544260bdd5dbba2935" title="xioctl" alt="" coords="134,5,186,32"/></map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a8d8f200cc041f8544260bdd5dbba2935"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static int xioctl </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>fd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>request</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>argp</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Do ioctl and retry if error was EINTR ("A signal was caught during the ioctl() operation."). Parameters are the same as on ioctl.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">fd</td><td>file descriptor </td></tr>
    <tr><td class="paramname">request</td><td>request </td></tr>
    <tr><td class="paramname">argp</td><td>argument </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>result from ioctl </dd></dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00306">306</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>, <a class="el" href="kb__camera_8c_source.html#l01087">kb_captureStart()</a>, <a class="el" href="kb__camera_8c_source.html#l01046">kb_captureStop()</a>, <a class="el" href="kb__camera_8c_source.html#l00360">mmapInit()</a>, and <a class="el" href="kb__camera_8c_source.html#l00429">userptrInit()</a>.</p>

</div>
</div>
<a class="anchor" id="a9805db4388486870b513f5246e889c04"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void YUV420toRGB888 </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Convert from YUV420 format to RGB888. Formulae are described on <a href="http://en.wikipedia.org/wiki/YUV">http://en.wikipedia.org/wiki/YUV</a></p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">width</td><td>width of image </td></tr>
    <tr><td class="paramname">height</td><td>height of image </td></tr>
    <tr><td class="paramname">src</td><td>source </td></tr>
    <tr><td class="paramname">dst</td><td>destination </td></tr>
  </table>
  </dd>
</dl>
<p>tmp++ = *py; tmp++ = *pu; tmp++ = *pv; </p>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00193">193</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c.html#a916e92ae9237b31e838e362c5e75ab51">CLIP</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00807">imageProcess()</a>.</p>

</div>
</div>
<a class="anchor" id="ad0d0aa54eaaf9770da0144705d892176"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void YUV420toYUV444 </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Convert from YUV420 format to YUV444.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">width</td><td>width of image </td></tr>
    <tr><td class="paramname">height</td><td>height of image </td></tr>
    <tr><td class="paramname">src</td><td>source </td></tr>
    <tr><td class="paramname">dst</td><td>destination </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00160">160</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<a class="anchor" id="ac07d4b713203275e34515fbf88a66a00"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void YUV422toRGB888 </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char *&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Convert from YUV422 format to RGB888. Formulae are described on <a href="http://en.wikipedia.org/wiki/YUV">http://en.wikipedia.org/wiki/YUV</a></p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">width</td><td>width of image </td></tr>
    <tr><td class="paramname">height</td><td>height of image </td></tr>
    <tr><td class="paramname">src</td><td>source </td></tr>
    <tr><td class="paramname">dst</td><td>destination </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00249">249</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>References <a class="el" href="kb__camera_8c.html#a916e92ae9237b31e838e362c5e75ab51">CLIP</a>.</p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a class="anchor" id="a3bdcdddaf116b83e1e4ee5f9f7d66da0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct <a class="el" href="structbuffer.html">buffer</a>* buffers = NULL</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00146">146</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

</div>
</div>
<a class="anchor" id="a5da66826e811349c98b2daf2bafb78c2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">char* deviceName = &quot;/dev/video6&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00134">134</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00697">deviceOpen()</a>.</p>

</div>
</div>
<a class="anchor" id="af235a7300301c4544d2ec5a980a26202"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int dHeight = 480</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00129">129</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01197">apply_filter()</a>, <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>, <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00807">imageProcess()</a>, <a class="el" href="kb__camera_8c_source.html#l01167">into_greyscale()</a>, <a class="el" href="kb__camera_8c_source.html#l00749">jpegWrite()</a>, and <a class="el" href="kb__camera_8c_source.html#l01296">kb_camera_init()</a>.</p>

</div>
</div>
<a class="anchor" id="ad1198d3ea2644952f5513716b093a40f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int dWidth = 752</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00128">128</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l01197">apply_filter()</a>, <a class="el" href="khepera4__test_8c_source.html#l01036">camera_example()</a>, <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00807">imageProcess()</a>, <a class="el" href="kb__camera_8c_source.html#l01167">into_greyscale()</a>, <a class="el" href="kb__camera_8c_source.html#l00749">jpegWrite()</a>, and <a class="el" href="kb__camera_8c_source.html#l01296">kb_camera_init()</a>.</p>

</div>
</div>
<a class="anchor" id="a6f8059414f0228f0256115e024eeed4b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int fd = -1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00138">138</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="crystalfontz634_8c_source.html#l00019">c634_open()</a>, <a class="el" href="kb__camera_8c_source.html#l00731">deviceClose()</a>, <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00697">deviceOpen()</a>, <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>, <a class="el" href="kb__camera_8c_source.html#l01360">kb_camera_release()</a>, <a class="el" href="kb__camera_8c_source.html#l01087">kb_captureStart()</a>, <a class="el" href="kb__camera_8c_source.html#l01046">kb_captureStop()</a>, <a class="el" href="kb__camera_8c_source.html#l00977">kb_frameRead()</a>, <a class="el" href="knet__rs232_8c_source.html#l00090">knet_rs232_open()</a>, <a class="el" href="kb__camera_8c_source.html#l00360">mmapInit()</a>, <a class="el" href="kb__camera_8c_source.html#l01388">take_one_image()</a>, and <a class="el" href="kb__camera_8c_source.html#l00429">userptrInit()</a>.</p>

</div>
</div>
<a class="anchor" id="a0256d25b86a9f6d108e63e630fd20cf2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int fps = -1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00132">132</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>.</p>

</div>
</div>
<a class="anchor" id="a86b667e9fcefc20145a0052a662dd961"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int initialised =0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00139">139</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00656">deviceUninit()</a>, and <a class="el" href="kb__camera_8c_source.html#l01388">take_one_image()</a>.</p>

</div>
</div>
<a class="anchor" id="aec080b31a9d99ef26786ddb817e892e1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27">io_method</a> io = <a class="el" href="kb__camera_8c.html#ac67fbcc615b56da3f9e3d51b1a2d2d27a086ff945a7be166d4e465dd5b8ae8749">IO_METHOD_MMAP</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00136">136</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00490">deviceInit()</a>, <a class="el" href="kb__camera_8c_source.html#l00656">deviceUninit()</a>, <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>, <a class="el" href="kb__camera_8c_source.html#l01087">kb_captureStart()</a>, <a class="el" href="kb__camera_8c_source.html#l01046">kb_captureStop()</a>, <a class="el" href="koreio_8c_source.html#l00449">kio_ChangePWM_ratio()</a>, and <a class="el" href="koreio__auto_8c_source.html#l00092">main()</a>.</p>

</div>
</div>
<a class="anchor" id="a4cb02037fe3d044e7df04e7ba730b48c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">char* jpegFilename</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00131">131</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00749">jpegWrite()</a>, and <a class="el" href="kb__camera_8c_source.html#l01468">save_buffer_to_jpg()</a>.</p>

</div>
</div>
<a class="anchor" id="aaada36991566317f46721dd5da76407e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char jpegQuality = 70</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00130">130</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00749">jpegWrite()</a>, and <a class="el" href="kb__camera_8c_source.html#l01468">save_buffer_to_jpg()</a>.</p>

</div>
</div>
<a class="anchor" id="afe157a787e311212531b003b24674227"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int n_buffers = 0</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Definition at line <a class="el" href="kb__camera_8c_source.html#l00148">148</a> of file <a class="el" href="kb__camera_8c_source.html">kb_camera.c</a>.</p>

<p>Referenced by <a class="el" href="kb__camera_8c_source.html#l00656">deviceUninit()</a>, <a class="el" href="kb__camera_8c_source.html#l00847">frameRead()</a>, <a class="el" href="kb__camera_8c_source.html#l01087">kb_captureStart()</a>, <a class="el" href="kb__camera_8c_source.html#l00360">mmapInit()</a>, and <a class="el" href="kb__camera_8c_source.html#l00429">userptrInit()</a>.</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="kb__camera_8c.html">kb_camera.c</a></li>
    <li class="footer">Generated on Wed Jul 6 2016 19:39:18 for Khepera Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.6 </li>
  </ul>
</div>
</body>
</html>
